
#if !defined(TEMPLATE_H_INCLUDED)
#define TEMPLATE_H_INCLUDED

template<class T>
class CList {
public:
	CList();
	~CList();
	void Add(const T &value);
	T RemoveFirst();
	void RemoveAll();
	int Count() { return count; }
	T& operator[](int i);
private:
	struct TItem { T value; TItem *next; };
	TItem *first,*last,*cachedP;
	int count,cached;
};

template <class T>
CList<T>::CList() {
	first = cachedP = NULL;
	count = 0;
}

template <class T>
CList<T>::~CList() {
	RemoveAll();
}

template <class T>
void CList<T>::RemoveAll() {
	while (first) {
		TItem* tmp = first->next;
		delete first; first = tmp;
	}
	first = cachedP = NULL;
	count = 0;
}

template <class T>
void CList<T>::Add(const T &value) {
	TItem* tmp = new TItem();
	tmp->value = value;
	tmp->next = NULL;
	if (first) last->next = tmp;
	else first = tmp;
	last = tmp;
	count++;
}

template <class T>
T CList<T>::RemoveFirst() {
	TItem* tmp = first;
	first = first->next;
	T value = tmp->value;
	delete tmp;
	count--;
	if (cached--==0) cachedP = NULL;
	return value;
}

template <class T>
T& CList<T>::operator[](int i) {
	TItem* act; int cnt;
	if (cachedP && (cached<=i)) {
		act = cachedP; cnt = cached;
	}
	else {
		act = first; cnt = 0;
	}
	while (act) {
		if (i==cnt++) {
			cachedP = act; cached = i;
			return cachedP->value;
		}
		act = act->next;
	}
	return first->value; // ERROR !
}

#endif
